CMSIS-DSP: Mean

| CMSIS-DSP Version 1.4.7 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Mean
Statistics Functions

## Functions
void | arm_mean_f32 (float32_t *pSrc, uint32_t blockSize, float32_t *pResult)
| Mean value of a floating-point vector.
void | arm_mean_q15 (q15_t *pSrc, uint32_t blockSize, q15_t *pResult)
| Mean value of a Q15 vector.
void | arm_mean_q31 (q31_t *pSrc, uint32_t blockSize, q31_t *pResult)
| Mean value of a Q31 vector.
void | arm_mean_q7 (q7_t *pSrc, uint32_t blockSize, q7_t *pResult)
| Mean value of a Q7 vector.

## Description

Calculates the mean of the input vector. Mean is defined as the average of the elements in the vector. The underlying algorithm is used:

            Result = (pSrc[0] + pSrc[1] + pSrc[2] + ... + pSrc[blockSize-1]) / blockSize;

There are separate functions for floating-point, Q31, Q15, and Q7 data types.

## Function Documentation

void arm_mean_f32 | ( | float32_t * | pSrc,
|  | uint32_t | blockSize,
|  | float32_t * | pResult
| ) |  |

Parameters

  [in] | *pSrc | points to the input vector
  [in] | blockSize | length of the input vector
  [out] | *pResult | mean value returned here

Returns
  none.

Examples:
  arm_class_marks_example_f32.c.

References blockSize.

Referenced by main().

void arm_mean_q15 | ( | q15_t * | pSrc,
|  | uint32_t | blockSize,
|  | q15_t * | pResult
| ) |  |

Parameters

  [in] | *pSrc | points to the input vector
  [in] | blockSize | length of the input vector
  [out] | *pResult | mean value returned here

Returns
  none.

Scaling and Overflow Behavior:

  The function is implemented using a 32-bit internal accumulator. The input is represented in 1.15 format and is accumulated in a 32-bit accumulator in 17.15 format. There is no risk of internal overflow with this approach, and the full precision of intermediate result is preserved. Finally, the accumulator is saturated and truncated to yield a result of 1.15 format.

References __SIMD32, and blockSize.

void arm_mean_q31 | ( | q31_t * | pSrc,
|  | uint32_t | blockSize,
|  | q31_t * | pResult
| ) |  |

Parameters

  [in] | *pSrc | points to the input vector
  [in] | blockSize | length of the input vector
  [out] | *pResult | mean value returned here

Returns
  none.

Scaling and Overflow Behavior:

  The function is implemented using a 64-bit internal accumulator. The input is represented in 1.31 format and is accumulated in a 64-bit accumulator in 33.31 format. There is no risk of internal overflow with this approach, and the full precision of intermediate result is preserved. Finally, the accumulator is truncated to yield a result of 1.31 format.

References blockSize.

void arm_mean_q7 | ( | q7_t * | pSrc,
|  | uint32_t | blockSize,
|  | q7_t * | pResult
| ) |  |

Parameters

  [in] | *pSrc | points to the input vector
  [in] | blockSize | length of the input vector
  [out] | *pResult | mean value returned here

Returns
  none.

Scaling and Overflow Behavior:

  The function is implemented using a 32-bit internal accumulator. The input is represented in 1.7 format and is accumulated in a 32-bit accumulator in 25.7 format. There is no risk of internal overflow with this approach, and the full precision of intermediate result is preserved. Finally, the accumulator is truncated to yield a result of 1.7 format.

References __SIMD32, and blockSize.